/*	
** Xmas (X memory access simulator) is a little memory (+cache) simulator.
** Copyright (C) 1997/98/99/00  <Paolo Dovera pd514314@silab.dsi.unimi.it>
**                              <Paolo Dovera pdovera@tiscalinet.it>

** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.

** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.

** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

** Send any bug reports or comments to pd514314@silab.dsi.unimi.it
**                                     pdovera@tiscalinet.it
*/

#ifndef EDIT_H
#define EDIT_H

/*
** Error/Message code
*/
#define EditPCoutMemory         601 
#define EditMuchIstrs           602
#define EditIstrUnKnown         603
#define EditFileWrong           604
#define EditNoProgram           605
#define EditCheckOK             606
#define EditCheckWrong          607
#define EditPCUnset             608
#define EditFileOpenError       609
#define EditCheckError          610
#define EditBufferPathTooLong   611
#define EditBufferPCTooLong     612
#define EditBufferNameTooLong   613
#define EditIstrError           614

/*
** Pop up the Editor
*/
void PopupEdit(Widget w, XEvent *event, String *params, Cardinal *num_params);
/*
** AutoLoad a source file when the loader get a file
*/
int EditorGetBufferFromFile(String filename, String name, String path, unsigned int startPC);
/*
** Active/Disable the Editor Auto Save
*/
int EditorActiveEAS(void);
int EditorDisableEAS(void);
/*
** Get the active buffer, its name and its directory
*/
void getProgram(String *program);
void getFileName(String filename);
void getFileDirectory(String directory);
void getStartPC(String StartPC);
/*
** Load and save the editor status
*/
int SaveEditStatus(String XmasDir);
int LoadEditStatus(void);
/*
** Return the total number buffer
*/
int GetNumBuffer(void);
int GetBufferFilename(int num,char *filename);
int getBufferProgram(int num,String *program);
#endif
