/*      
** Xmas (X memory access simulator) is a little memory (+cache) simulator.
** Copyright (C) 1997/98/99/00  <Paolo Dovera pd514314@silab.dsi.unimi.it>
**                              <Paolo Dovera pdovera@tiscalinet.it>

** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.

** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.

** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

** Send any bug reports or comments to pd514314@silab.dsi.unimi.it
**                                     pdovera@tiscalinet.it
*/

/*
** generals include
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/*
** Intrinsics Definitions
*/

/*
** include of application modules and images
*/
#include "esp.h"

/*
** Public include file for widgets I actually use in this file.
*/

/* BEGIN LOCAL DEFINE */
#define DIM 8
/* END LOCAL DEFINE */

/* BEGIN IMPORTED GLOABAL VARIABLES */
extern int errno, sys_nerr;
/* END IMPORTED GLOABAL VARIABLES */

/* BEGIN EXPORTABLE GLOBAL VARIABLES */
/* END EXPORTABLE GLOBAL VARIABLES */

/* BEGIN STATIC FUNCTION (PRIVATE FUNCTION) */
/* END STATIC FUNCTION (PRIVATE FUNCTION) */

/* BEGIN STATIC GLOBAL VARIABLES (PRIVATE VARIABLES) */
/* END STATIC GLOBAL VARIABLES (PRIVATE VARIABLES) */

unsigned int esp (unsigned int base, unsigned int esponente)
     /*
     ** esponente > 0
     ** base^esponente
     */
{
  unsigned int i, ris = 1;

  for (i = 0; i < esponente; i++)
    ris = ris * base;
  return (ris);
}

void stampabit (int valint) /* pag. 246 of "Il linguaggio C" Hancock,Krieger */
     /*
     ** Show the string of bit
     */
{
  int i;

  for (i = 0; i < DIM * sizeof (int); ++i)
    printf ("%d", (valint << i & 1 << (DIM * sizeof (int) - 1)) ? 1 : 0);
  (void)putchar ('\n');
}

void stampabitinstring (unsigned int valint, char *string)
     /*
     ** Write the string of bit into a char string
     */
{
  int i;

  for (i = 0; i < DIM * sizeof (int); ++i)
    if (valint << i & 1 << (DIM * sizeof (int) - 1))
      string[i] = '1';
    else
      string[i] = '0';
}

int bit2int (char *stringbit)
     /*
     ** Convert a number from binary string format to numeric format
     */
{
  unsigned int i;
  int number = 0;
  char *punt;

  punt = stringbit + strlen (stringbit);
  for (i = 0; --punt >= stringbit; i++)
    if (*punt == '0')
      continue;
    else
      number += esp (2, i);
  return (number);
}

void syserr (char *msg)
     /*
     ** Print system call error message and terminate
     */
{
  fprintf (stderr, "ERROR: %s (%d", msg, errno);
  if (errno > 0 && errno < sys_nerr)
    fprintf (stderr, "; %s)\n", strerror(errno));
  else
    fprintf (stderr, ")\n");
  exit (EXIT_SUCCESS);
}

void debug (char *file, char *function, int line, char *message, char *string, int number)
     /*
     ** To print a debug message
     */
{
  printf ("%s:%s:%d: %s %s %d\n", file, function, line, message, string, number);
}
