/*	
** Xmas (X memory access simulator) is a little memory (+cache) simulator.
** Copyright (C) 1997/98/99/00  <Paolo Dovera pd514314@silab.dsi.unimi.it>
**                              <Paolo Dovera pdovera@tiscalinet.it>

** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.

** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.

** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

** Send any bug reports or comments to pd514314@silab.dsi.unimi.it
**                                     pdovera@tiscalinet.it
*/

#ifndef LOADER_H
#define LOADER_H

/*
** Error/Message code
*/
#define SetCacheSizeError 50
#define SetMemorySizeError 52
#define SetMemorySizenotenough 54
#define SetNWayError 51
#define SetRegisterError 53

/*
** Values returned by loader
*/
#define LoaderExceededMinShiftAmount 318
#define LoaderExceededMaxShiftAmount 317
#define LoaderExceededImmField 316
#define LoaderWhithoutIMM 315
#define LoaderWhithoutRS 314
#define LoaderWhithoutRT 313
#define LoaderWhithoutRD 312
#define ExecLWWrongAddres 311
#define ExecSWWrongAddres 310
#define LoaderExceededMaxReg 309
#define LoaderIncompleteNWayError 308
#define LoaderDataError 307
#define LoaderPCError 306
#define LoaderOutPC 305
#define LoaderFileIncomplete 304
#define LoaderFileError 303
#define LoaderIstrError 302
#define LoaderUnknownError 301
#define LoaderExactCode 300

/*
** PAY ATTENTION !!!
** LOADER CODE UNDER THIS LINE
** DO NOT CUNFUSE
*/
void inizializza_loader(void);
unsigned int loader(char *nome_file,unsigned int *PC, char *istr_string,
		    int *line_counter);
unsigned int String2Istr(char *AlfaNumIstruction,
			 unsigned int *NumericIstruction);
/*
** END LOADER
*/

/*
** PAY ATTENTION !!!
** UNLOADER CODE UNDER THIS LINE
** DO NOT CUNFUSE
*/

/*
** Error/Message code
*/
/*
** Values returned by unloader
*/
#define UnloaderWrongShiftAmount 203
#define UnloaderExceededMaxReg 202
#define UnloaderIstrError 201
#define UnloaderExactDecode 200

int unloader(unsigned int ProgramCounter,char *string);
int Istr2String(unsigned int istr, char *string);
/*
** END UNLOADER
*/

/*
** PAY ATTENTION !!!
** ESECUTORE CODE UNDER THIS LINE
** DO NOT CUNFUSE
*/
#define MaxReg 16 /* number of register of the VirtualCPU without hi&lo */
#define RegHi MaxReg+0
#define RegLo MaxReg+1
#define UnKnownIstr -1

/*
** Error/Message code
*/
/*
** Values returned by esegui
*/
#define ExecSAOutOfRange        113
#define ExecDivByZero           112
#define ExecZeroDivMultError    111
#define ExecSmallZeroFieldError 110
#define ExecZeroFieldError      109
#define ExecOutPC               108
#define ExecIstrLimit           107
#define ExecOutofTime           106
#define ExecBreakPoint          105
#define ExecWriteonROR          104
#define ExecHalt                103
#define ExecExceededMaxReg      102
#define ExecIstrError           101
#define ExecExactExecution      100

int execrun(unsigned int *PC);
void setSbS(void);
void setFR(void);
int toggleBP(void);
int getBP(void);
int toggleTL(void);
int toggleIT(void);
int togglePE(void);
int ritornaregistro(unsigned int Indice);
void resetregistri(void);
int setregistro(int numero_registro, int value);
/*
** END EXECUTOR
*/

/*
** ISTRUCTION COUNTER VALUES RETURNED
*/
#define IstrIndexOutBound 1500

/*
** ISTRUCTION COUNTER FUNCTIONS
*/
unsigned int get_istruction_count(unsigned int index);
int get_istruction_name(unsigned int index, char *name, unsigned int name_size);
int reset_istruction_count(void);
unsigned int get_num_istruction(void);

/*
** MISCELLENIA FUNCTIONS
*/
int getMaxBreakLine(void);
int getBreakLinePC(int index, int *value);
int getBreakLine(int index, int *value, int *reg, int *cost,char *testkind);
int setBreakLine(int index, int value, int reg, int cost1,char testkind);
int reset_breakline(void);
int clearBreakLine(int index);
void compactBreakLine(unsigned int index);

/*
** LOAD/SAVE
*/
int SaveRegistersStatus(char *XmasDir);
int SaveBreakpointsStatus(char *XmasDir);
int SaveExecutorValues(char *XmasDir);
/*
** END LOAD/SAVE
*/

unsigned int getOutofTimeLimit(void);
unsigned int getMinOutofTimeLimit(void);
unsigned int getMaxOutofTimeLimit(void);
int setOutofTimeLimit(unsigned int newvalue);
unsigned int getIstrLimit(void);
unsigned int getMinIstrLimit(void);
unsigned int getMaxIstrLimit(void);
int setIstrLimit(unsigned int newvalue);
#endif
