/*	
** Xmas (X memory access simulator) is a little memory (+cache) simulator.
** Copyright (C) 1997/98/99/00  <Paolo Dovera pd514314@silab.dsi.unimi.it>
**                              <Paolo Dovera pdovera@tiscalinet.it>

** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.

** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.

** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

** Send any bug reports or comments to pd514314@silab.dsi.unimi.it
**                                     pdovera@tiscalinet.it
*/

/*
** Essential include
*/
#include <stdio.h>

/*
** Include files required for all Toolkit programs
*/
#include <X11/Intrinsic.h>     /* Intrinsics Definitions*/
#include <X11/StringDefs.h>    /* Standard Name-String definitions*/

/*
** Public include file for widgets we actually use in this file.
*/
#include <X11/Xlib.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Shell.h>

/*
** include of application modules
*/
#include "ErrorMessage.h"
#include "menu.h"
#include "menuHELP.h"
#include "images/question"
#include "global.h"

/* BEGIN LOCAL DEFINE */
#define NUM_MENU_FILE 3
/* END LOCAL DEFINE */

/* BEGIN IMPORTED GLOABAL VARIABLES */
/* END IMPORTED GLOABAL VARIABLES */

/* BEGIN EXPORTABLE GLOBAL VARIABLES */
/* END EXPORTABLE GLOBAL VARIABLES */

/* BEGIN STATIC FUNCTION (PRIVATE FUNCTION) */
static void PopupDialogHelpAuthor(Widget w,XtPointer client_data,
				  XtPointer call_data);
/* END STATIC FUNCTION (PRIVATE FUNCTION) */

/* BEGIN STATIC GLOBAL VARIABLES (PRIVATE VARIABLES) */
static Widget entryMenuHelp[NUM_MENU_FILE];
static Widget buttonhelp, menuhelp;
static Pixmap question;
/* END STATIC GLOBAL VARIABLES (PRIVATE VARIABLES) */

/*
** Callback
*/
static void PopupDialogHelpAuthor(Widget w, XtPointer client_data, XtPointer call_data)
     /*
     ** Show the message for contact me or the help
     */
{
  int message = (int) client_data;

  ErrorMessage(message,NULL,NULL,0);
}

void InitializemenuHELP(Widget form)
{
   int i;
   char name[ShortBufferLength];

   /* Menu File */
   buttonhelp = XtVaCreateManagedWidget(
	"buttonhelp",
	menuButtonWidgetClass,
	form,
	XtNmenuName,"menuhelp",
	NULL);

   menuhelp = XtCreatePopupShell(
	"menuhelp",
	simpleMenuWidgetClass,
	buttonhelp,
	NULL,
        0);

   for (i=0; i < NUM_MENU_FILE; i++) {
     sprintf(name,"help%d",i+1);
     entryMenuHelp[i] = XtCreateManagedWidget(name, smeBSBObjectClass,
					      menuhelp, NULL, 0);
   }
   XtAddCallback(entryMenuHelp[0], XtNcallback, PopupDialogHelpAuthor,
		 (XtPointer)Help);
   XtAddCallback(entryMenuHelp[1], XtNcallback, PopupDialogHelpAuthor,
		 (XtPointer)Author);
   XtAddCallback(entryMenuHelp[2], XtNcallback, PopupDialogHelpAuthor,
		 (XtPointer)Copyright);
   question=XCreateBitmapFromData(XtDisplay(buttonhelp),
				  RootWindowOfScreen(XtScreen(buttonhelp)),
				 question_bits,question_width,question_height);
   XtVaSetValues(buttonhelp,XtNleftBitmap,question,NULL);
}
