/*	
** Xmas (X memory access simulator) is a little memory (+cache) simulator.
** Copyright (C) 1997/98/99/00  <Paolo Dovera pd514314@silab.dsi.unimi.it>
**                              <Paolo Dovera pdovera@tiscalinet.it>

** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.

** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.

** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

** Send any bug reports or comments to pd514314@silab.dsi.unimi.it
**                                     pdovera@tiscalinet.it
*/

/*
** generals include
*/
#include <stdio.h>

/*
** Include files required for all Toolkit programs
*/
#include <X11/Intrinsic.h>     /* Intrinsics Definitions*/
#include <X11/StringDefs.h>    /* Standard Name-String definitions*/

/*
** Public include file for widgets we actually use in this file.
*/
#include <X11/Xlib.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Shell.h>

/*
** include of application modules
*/
#include "menu.h"
#include "global.h"
#include "Sizer.h"
#include "loader.h"

/* BEGIN LOCAL DEFINE */
/* END LOCAL DEFINE */

/* BEGIN IMPORTED GLOABAL VARIABLES */
/* END IMPORTED GLOABAL VARIABLES */

/* BEGIN EXPORTABLE GLOBAL VARIABLES */
/* END EXPORTABLE GLOBAL VARIABLES */

/* BEGIN STATIC FUNCTION (PRIVATE FUNCTION) */
static void TimeLimitTuning(Widget w, XtPointer client_data,XtPointer call_data);
static void IstrLimitTuning(Widget w, XtPointer client_data,XtPointer call_data);
static void NewTimeLimit(int num);
static void NewIstrLimit(int num);
/* END STATIC FUNCTION (PRIVATE FUNCTION) */

/* BEGIN STATIC GLOBAL VARIABLES (PRIVATE VARIABLES) */
#define NUM_MENU_TUNING 2
static Widget entryMenuTuning[NUM_MENU_TUNING];
static Widget buttontuning, menutuning;
/* END STATIC GLOBAL VARIABLES (PRIVATE VARIABLES) */

void InitializemenuTUNING(Widget form)
     /*
     ** Create the menu TUNING
     */
{
   int i;
   char name[ShortBufferLength];

   /* Menu TUNING */
   buttontuning = XtVaCreateManagedWidget(
	"buttontuning",
	menuButtonWidgetClass,
	form,
	XtNmenuName,"menutuning",
	NULL);
   menutuning = XtCreatePopupShell(
	"menutuning",
	simpleMenuWidgetClass,
	buttontuning,
	NULL,
        0);

   for (i=0; i < NUM_MENU_TUNING; i++) {
     sprintf(name,"tuning%d",i+1);
     entryMenuTuning[i] = XtCreateManagedWidget(name, smeBSBObjectClass,
						menutuning, NULL, 0);
   }
   XtAddCallback(entryMenuTuning[0], XtNcallback, TimeLimitTuning,
		 entryMenuTuning[0]);
   XtAddCallback(entryMenuTuning[1], XtNcallback, IstrLimitTuning,
		 entryMenuTuning[1]);
}

static void TimeLimitTuning(Widget w, XtPointer client_data,XtPointer call_data)
{
  PopupSizerDecimal(getMinOutofTimeLimit(),getMaxOutofTimeLimit(),getOutofTimeLimit(),NewTimeLimit);
}

static void IstrLimitTuning(Widget w, XtPointer client_data,XtPointer call_data)
{
  PopupSizerDecimal(getMinIstrLimit(),getMaxIstrLimit(),getIstrLimit(),NewIstrLimit);
}

static void NewTimeLimit(int num)
{
  setOutofTimeLimit(num);
}

static void NewIstrLimit(int num)
{
  setIstrLimit(num);
}
