/*	
** Xmas (X memory access simulator) is a little memory (+cache) simulator.
** Copyright (C) 1997/98/99/00  <Paolo Dovera pd514314@silab.dsi.unimi.it>
**                              <Paolo Dovera pdovera@tiscalinet.it>

** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.

** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.

** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

** Send any bug reports or comments to pd514314@silab.dsi.unimi.it
**                                     pdovera@tiscalinet.it
*/

#include <stdio.h>

/*
** Include files required for all Toolkit programs
*/
#include <X11/Intrinsic.h>     /* Intrinsics Definitions*/
#include <X11/StringDefs.h>    /* Standard Name-String definitions*/

/*
** Public include file for widgets I actually use in this file.
*/
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
/*#include <X11/Xaw/SmeLine.h>*/
#include <X11/Shell.h>

#include "menu.h"
#include "pathexec.h"
#include "Edit.h"
#include "BrPts.h"
#include "MemEditor.h"
#include "Calc.h"
#include "global.h"

#define NUM_MENU_FILE 5

/* BEGIN LOCAL DEFINE */
/* END LOCAL DEFINE */

/* BEGIN IMPORTED GLOABAL VARIABLES */
/* END IMPORTED GLOABAL VARIABLES */

/* BEGIN EXPORTABLE GLOBAL VARIABLES */
/* END EXPORTABLE GLOBAL VARIABLES */

/* BEGIN STATIC FUNCTION (PRIVATE FUNCTION) */
static void PopupDialogEdit(Widget w,XtPointer client_data,
			    XtPointer call_data);
static void PopupDialogBP(Widget w,XtPointer client_data,
			    XtPointer call_data);
static void GenericPopup(Widget w, XtPointer client_data, XtPointer call_data);
static void PopupCalc_callback(Widget w, XtPointer client_data, XtPointer call_data);
static void ExecPath(Widget w, XtPointer client_data, XtPointer call_data);
/* END STATIC FUNCTION (PRIVATE FUNCTION) */

/* BEGIN STATIC GLOBAL VARIABLES (PRIVATE VARIABLES) */
/* END STATIC GLOBAL VARIABLES (PRIVATE VARIABLES) */

/*
** Callback
*/
static void PopupDialogEdit(Widget w, XtPointer client_data, XtPointer call_data)
     /*
     ** Popup the editor
     */
{
  /* 
  ** menuwindow is used as dummy widget to know that must call XtPopup
  ** see PopupEdit(...) in Edit.c for more details
  */
  PopupEdit(NULL,NULL,NULL,NULL); /* from Edit.c */
}

/*
** Callback
*/
static void PopupDialogBP(Widget w, XtPointer client_data, XtPointer call_data)
     /*
     ** Popup the editor
     */
{
   PopupBrPts(NULL,NULL,NULL,NULL); /* from BrPts.c */
}

/*
** Callback
*/
static void GenericPopup(Widget w, XtPointer client_data, XtPointer call_data)
     /*
     ** Popup the editor
     */
{
  PopupMemEditor(NULL,NULL,NULL,NULL); /* from BrPts.c */
}

/*
** Callback
*/
static void PopupCalc_callback(Widget w, XtPointer client_data, XtPointer call_data)
     /*
     ** Popup the editor
     */
{
  PopupCalc(NULL,NULL,NULL,NULL);
}

/*
** Callback
*/
static void ExecPath(Widget w, XtPointer client_data, XtPointer call_data)
     /*
     ** Popup Execpath, the unrolling shell
     */
{
  PopupExecutionPath(NULL,NULL,NULL,NULL);
}

void InitializemenuWINDOW(Widget form)
     /*
     ** Create the menu Options
     */
{
   int i;
   char name[ShortBufferLength];
   Widget buttonwindow,menuwindow;
   Widget entryMenuWindow[NUM_MENU_FILE];

   /* Menu Window */
   buttonwindow = XtVaCreateManagedWidget(
	"buttonwindow",
	menuButtonWidgetClass,
	form,
	XtNmenuName,"menuwindow",
	NULL);
   menuwindow = XtCreatePopupShell(
	"menuwindow",
	simpleMenuWidgetClass,
	buttonwindow,
	NULL,
        0);

   for (i=0; i < NUM_MENU_FILE; i++) {
     sprintf(name,"window%d",i+1);
     entryMenuWindow[i] = XtCreateManagedWidget(name, smeBSBObjectClass,
						menuwindow, NULL, 0);
   }
   XtAddCallback(entryMenuWindow[0], XtNcallback, PopupDialogEdit,
		 (XtPointer)0);
   XtAddCallback(entryMenuWindow[1], XtNcallback, PopupDialogBP,
		 (XtPointer)0);
   XtAddCallback(entryMenuWindow[2], XtNcallback, GenericPopup,
		 (XtPointer)0);
   XtAddCallback(entryMenuWindow[3], XtNcallback, PopupCalc_callback,
		 (XtPointer)0);
   XtAddCallback(entryMenuWindow[4], XtNcallback, ExecPath,
		 (XtPointer)0);
}
