/*	
** Xmas (X memory access simulator) is a little memory (+cache) simulator.
** Copyright (C) 1997/98/99/00  <Paolo Dovera pd514314@silab.dsi.unimi.it>
**                              <Paolo Dovera pdovera@tiscalinet.it>

** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.

** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.

** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

** Send any bug reports or comments to pd514314@silab.dsi.unimi.it
**                                     pdovera@tiscalinet.it
*/

/*
** generals include
*/
#include <stdio.h>
#include <string.h>

/*
** Intrinsics Definitions
*/

/*
** include of application modules
*/
#include "general_support.h"
#include "opthandler.h"
/*#include "esp.h"*/
#include "global.h"

/*
** Public include file for widgets I actually use in this file.
*/

/* BEGIN LOCAL DEFINE */
#define LF '\n'
/* END LOCAL DEFINE */

/* BEGIN IMPORTED GLOABAL VARIABLES */
/* END IMPORTED GLOABAL VARIABLES */

/* BEGIN EXPORTABLE GLOBAL VARIABLES */
/* END EXPORTABLE GLOBAL VARIABLES */

/* BEGIN STATIC FUNCTION (PRIVATE FUNCTION) */
/* END STATIC FUNCTION (PRIVATE FUNCTION) */

/* BEGIN STATIC GLOBAL VARIABLES (PRIVATE VARIABLES) */
/* END STATIC GLOBAL VARIABLES (PRIVATE VARIABLES) */

int getOptionFromName(char *OptFileName, char *OptName, char *RetValue, unsigned int RetSize)
     /*
     ** Read the value associated to preference OptName in file OptFileName
     ** Return the value accross RetValue with size RetSize
     */
{
  FILE *fp;
  char Path[LongBufferLength];
  char row[MediumBufferLength];
  char *LineFeed;

  XmasDirStatus(Path,sizeof(Path));
  strcat(Path,"/");
  strcat(Path,OptFileName);
  if ((fp=fopen(Path,"r")) != NULL) {
    while (fgets(row,(int)sizeof(row),fp) != NULL) {
      if (*row == '#') /* skip comment */
	continue;
      if (strncmp(row,OptName,strlen(OptName)) == 0) {
	strncpy(RetValue,row+strlen(OptName),(size_t)RetSize);
	if ((LineFeed=strchr(RetValue,LF)) != NULL)
	  *LineFeed='\0';
	fclose(fp);
	return(True);
      }
    }
    fclose(fp);
  }
  return(False);
}

int getBoolOptionsValue(char *RetValue)
     /*
     ** Reurn the value of an bool option
     */
{
  if ((RetValue[1]=='t') || (RetValue[1]=='T') ||
      (RetValue[1]=='y') || (RetValue[1]=='Y'))
    return(True);
  return(False);
}

int TestOptionValueString(char *RetValue, char *testvalue)
     /*
     ** Check if the option value is the same of testvalue
     ** string comparison
     */
{
  if (strcmp(&(RetValue[1]),testvalue) == 0)
    return(True);
  return(False);
}

int TestOptionValueFirstChar(char *RetValue, char testvalue)
     /*
     ** Check only if the first char of the option is the same of testvalue
     ** first character comparison only
     */
{
  if (RetValue[1] == testvalue)
    return(True);
  return(False);
}

char *DefaultGeneralPreferences(void)
     /*
     ** Return the default general preferences
     */
{
  static char DefaultPreferences[]="### DEFAULT MISCELLANEOUS USER PREFERENCES\n\
### T,t,Y,y => active\n\
### F,f,N,n => disable\n\
\n\
# Directory for temporary files\n\
#\n\
TmpDir=/tmp/\n\
\n\
# Welcome message at startup\n\
#\n\
Welcome=T";

  return(DefaultPreferences);
}

char *DefaultEditorPreferences(void)
     /*
     ** Return the default editor preferences
     */
{
  static char DefaultEditor[]="### DEFAULT USER EDITOR PREFERENCES\n\
\n\
### NOT YET SUPPORTED";
  return(DefaultEditor);
}

char *DefaultEmailPreferences(void)
     /*
     ** Return the default email preferences
     */
{
  static char DefaultEditor[]="### DEFAULT USER EMAIL PREFERENCES\n\
\n\
# Command to send an email without cc: and bcc:\n\
#\n\
EmailProg=mail -n";
  return(DefaultEditor);
}

char *DefaultPrintPreferences(void)
     /*
     ** Return the default general preferences
     */
{
  static char DefaultPreferences[]="### DEFAULT USER PRINT PREFERENCES\n\
\n\
# The command to print a buffer as text with CRLF\n\
# the first %s is the file to print\n\
# the second %s is the name printer\n\
#\n\
TextCRLF=cat %s | todos | lpr -P%s\n\
\n\
# The command to print a buffer as text with only LF\n\
# the first %s is the file to print\n\
# the second %s is the name printer\n\
#\n\
TextLF=cat %s | lpr -P%s\n\
\n\
# The command to print a buffer with LaTeX\n\
# the first %s is the file to print\n\
# the fourth %s is the name printer\n\
#\n\
LaTeX=latex %s;dvips %s.dvi -o %s.ps;lpr -P%s %s.ps";

  return(DefaultPreferences);
}

char *DefaultCachePreferences(void)
     /*
     ** Return the default cache preferences
     */
{
  static char DefaultPreferences[]="### DEFAULT CACHE PREFERENCES\n\
### T,t,Y,y => active\n\
### F,f,N,n => disable\n\
\n\
# Allow to save the cache status accross user work session\n\
#\n\
CacheEntrySave=T";

  return(DefaultPreferences);
}

char *DefaultMemoryPreferences(void)
     /*
     ** Return the default memory preferences
     */
{
  static char DefaultPreferences[]="### DEFAULT MEMORY PREFERENCES\n\
### T,t,Y,y => active\n\
### F,f,N,n => disable\n\
\n\
# Allow to save the memory status accross user work session\n\
#\n\
MemoryEntrySave=T";

  return(DefaultPreferences);
}

char *DefaultRegisterPreferences(void)
     /*
     ** Return the default registers preferences
     */
{
  static char DefaultPreferences[]="### DEFAULT REGISTER PREFERENCES\n\
### T,t,Y,y => active\n\
### F,f,N,n => disable\n\
\n\
# To save the registers status accross user work session\n\
#\n\
RegEntrySave=T";

  return(DefaultPreferences);
}

char *DefaultBreakpointsPreferences(void)
     /*
     ** Return the default breakpoints preferences
     */
{
  static char DefaultPreferences[]="### DEFAULT BREAKPOINTS PREFERENCES\n\
### T,t,Y,y => active\n\
### F,f,N,n => disable\n\
\n\
# To save the breakpoints status accross user work session\n\
#\n\
BreakpointsSave=T";

  return(DefaultPreferences);
}

char *DefaultExecutorPreferences(void)
     /*
     ** Return the default executor preferences
     */
{
  static char DefaultPreferences[]="### DEFAULT EXECUTOR PREFERENCES\n\
### T,t,Y,y => active\n\
### F,f,N,n => disable\n\
\n\
# Allow to save the TimeLimit value accross user work session\n\
#\n\
TimeLimitSave=T\n\
\n\
# Allow to save the IstrLimit value accross user work session\n\
#\n\
IstrLimitSave=T";

  return(DefaultPreferences);
}

char *DefaultPathTracerPreferences(void)
     /*
     ** Return the default pathtracer preferences
     */
{
  static char DefaultPreferences[]="### DEFAULT PATHTRACER PREFERENCES\n\
### T,t,Y,y => active\n\
### F,f,N,n => disable\n\
\n\
# Where to store tracing information when the tool is active\n\
# available value:\n\
# M => store tracing information in memory\n\
# D => store tracing information into a file\n\
#      good for long execution to save memory\n\
#\n\
Store=M";

  return(DefaultPreferences);
}
