/*	
** Xmas (X memory access simulator) is a little memory (+cache) simulator.
** Copyright (C) 1997/98/99/00  <Paolo Dovera pd514314@silab.dsi.unimi.it>
**                              <Paolo Dovera pdovera@tiscalinet.it>

** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.

** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.

** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

** Send any bug reports or comments to pd514314@silab.dsi.unimi.it
**                                     pdovera@tiscalinet.it
*/

#ifndef OPTHANDLER_H
#define OPTHANDLER_H

/*
** preferences files and relatives names
*/
#define GeneralPreferencesFile "general.prf"
#define TmpDir "TmpDir="
#define WelcomeOpt "Welcome"

#define EditorPreferencesFile "editor.prf"

#define EmailPreferencesFile "email.prf"
#define EmailProgOpt "EmailProg"

#define PrintPreferencesFile "print.prf"
#define PrintTextCRLF "TextCRLF="
#define PrintTextLF   "TextLF="
#define PrintLaTeX    "LaTeX="

#define MemoryPreferencesFile "memory.prf"
#define MemoryEntrySaveOpt "MemoryEntrySave"
#define MemorySaveDataFile "memory"
#define MemoryEntrySaveLdm "Ldm"
#define MemoryAlphaNumericOptString "AlphaNumeric:"

#define CachePreferencesFile "cache.prf"
#define CacheEntrySaveOpt "CacheEntrySave"
#define CacheSaveDataFile "cache"
#define CacheEntrySaveLdc "Ldc"
#define CacheWriteOptString   "Write:"
#define CacheReplaceOptString "Replacement:"
#define CacheSizeOptString    "Size:"
#define CacheTotalOptString   "Total:"
#define CacheMissOptString    "Miss:"
#define CacheAlphaNumericOptString "AlphaNumeric:"
#define CachePolicyOptString "Policy:"
#define CacheWayOptString    "Way:"

#define RegisterPreferencesFile "reg.prf"
#define RegisterEntrySaveOpt "RegEntrySave"
#define RegisterSaveDataFile "reg"
#define RegisterEntrySaveReg "Reg"
#define RegisterEntrySaveHi "Hi"
#define RegisterEntrySaveLo "Lo"

#define BreakpointsPreferencesFile "breakpoints.prf"
#define BreakpointsSaveOpt "BreakpointsSave"
#define BreakpointsSaveDataFile "breakpoints"
#define BreakpointsSaveBP "BP"

#define ExecutorPreferencesFile "executor.prf"
#define ExecutorSaveDataFile "executor"
#define ExecutorTimeLimitSaveOpt  "TimeLimitSave"
#define ExecutorTimeLimitSave "TimeLimit:"
#define ExecutorIstrLimitSaveOpt  "IstrLimitSave"
#define ExecutorIstrLimitSave "IstrLimit:"

#define PathTracerPreferencesFile "pathtracer.prf"
#define PathTracerStoreOpt "Store"

int getOptionFromName(char *OptFileName, char *OptName, char *RetValue, unsigned int RetSize);
int getBoolOptionsValue(char *RetValue);
int TestOptionValueString(char *RetValue, char *testvalue);
int TestOptionValueFirstChar(char *RetValue, char testvalue);

char *DefaultGeneralPreferences(void);
char *DefaultEditorPreferences(void);
char *DefaultEmailPreferences(void);
char *DefaultPrintPreferences(void);
char *DefaultRegisterPreferences(void);
char *DefaultCachePreferences(void);
char *DefaultMemoryPreferences(void);
char *DefaultBreakpointsPreferences(void);
char *DefaultExecutorPreferences(void);
char *DefaultPathTracerPreferences(void);
#endif

