/*	
** Xmas (X memory access simulator) is a little memory (+cache) simulator.
** Copyright (C) 1997/98/99/00  <Paolo Dovera pd514314@silab.dsi.unimi.it>
**                              <Paolo Dovera pdovera@tiscalinet.it>

** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.

** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.

** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

** Send any bug reports or comments to pd514314@silab.dsi.unimi.it
**                                     pdovera@tiscalinet.it
*/

#ifndef PATHEXEC_H
#define PATHEXEC_H

/*
** Error/Message code
*/
#define PathExecFileWrong 1800

/*
** Path tracer environment function
*/
int StartPathTracer(void);
int StopPathTracer(void);

/*
** General functions
*/
void InitializeExecutionPath(void);

unsigned int IsShowedExecutionPath(void);
unsigned int IsActiveExecutionPath(void);
void ActiveExecutionPath(int mode);
void PopupExecutionPath(Widget w, XEvent *event, String *params, Cardinal *num_params);
int (*TracePC)(unsigned int PC);
void UpdateShowText(void);
/*
** strlen(message)+strlen(newstatus) < MaxStringLength (from global.h)
*/
void PEMessageChangeStatus(char *message,char *newstatus);
#endif
